
//  MatoPanelApplication.java  (c) Kari Laitinen

//  JPanel-luokkaan perustuva applikaatio, eli paikallisesti
//  suoritettava Java-ohjelma.


//  2014-11-24  Tiedosto luotu vastaavan apletin perusteella.
//  2014-11-24  Viimeisin muutos.

import java.awt.* ;
import java.util.* ;
import javax.swing.* ;
import java.awt.event.* ; // WindowListener, WindowEvent


class MatoPanel extends JPanel implements Runnable
{
   Thread  tahdistussaie ;

   boolean  saietta_on_suoritettava  =  false ;

   Color   kaytossa_oleva_vari      =  Color.red ;

   int  madon_paikka_x  =    0 ;
   int  madon_paikka_y  =  150 ;

   int  madon_pituus    =  100 ;
   int  madon_korkeus   =   30 ;

   int  paneelin_leveys, paneelin_korkeus ;

   public MatoPanel( int annettu_paneelin_leveys,
                     int annettu_paneelin_korkeus )
   {
      paneelin_leveys   =  annettu_paneelin_leveys ;
      paneelin_korkeus  =  annettu_paneelin_korkeus ;
   }

   public void kaynnista_saie()
   {
      if ( tahdistussaie  ==  null )
      {
         tahdistussaie  =  new  Thread( this ) ;
         saietta_on_suoritettava  =  true ;

         tahdistussaie.start() ;
      }
   }

   public void lopeta_saie()
   {
      if ( tahdistussaie  !=  null )
      {
         tahdistussaie.interrupt() ;
         saietta_on_suoritettava  =  false ;
         tahdistussaie  =  null ;
      }
   }

   public void run()
   {
      while ( saietta_on_suoritettava  ==  true )
      {
         madon_paikka_x  =   0 ;
         madon_pituus    = 100 ;

         repaint() ;

         lepuuta_tata_saietta( 2000 ) ;

         while ( madon_paikka_x  +  madon_pituus  <  paneelin_leveys  &&
                 saietta_on_suoritettava  ==  true )
         {
            for ( int venytyslaskuri  =  0 ;
                      venytyslaskuri  <  7 ;
                      venytyslaskuri  ++ )
            {
               madon_pituus  =  madon_pituus  + 5 ;

               repaint() ;
               lepuuta_tata_saietta( 50 ) ;
            }

            for ( int supistuslaskuri  =  0 ;
                      supistuslaskuri  <  7 ;
                      supistuslaskuri  ++ )
            {
               madon_pituus    =  madon_pituus    -  5 ;
               madon_paikka_x  =  madon_paikka_x  +  5 ;

               repaint() ;
               lepuuta_tata_saietta( 50 ) ;
            }
         }

         lepuuta_tata_saietta( 4000 ) ;
      }  
   }

   void  lepuuta_tata_saietta( int lepuutusaika_millisekunteina )
   {
      //  Ilman seuraavaa if-rakennetta syntyy sellainen ongelma
      //  ett sie ei pyshdy nopeasti mm. silloin kun matoa nyttv
      //  ikkuna minimoidaan. Esim. MatoOlioAppletissa tm metodi on
      //  kirjoitettu ilman if-rakennetta ja siin on sellainen ongelma
      //  ett jos ikkuna minimoidaan ja maksimoidaan heti pern madon
      //  ollessa ruudun keskivaiheilla, mato alkaa uuden sikeen 
      //  kynnistytty kyttyty hyvin omituisesti. Ilmeisesti tm
      //  johtuu siit ett sek uusi tahdistussie ett vanha sie
      //  muuttelevat yht aikaa madon pituutta ja madon x-paikkaa.
      //  Vanha sie jatkaa elmns kun saietta_on_suoritettava
      //  pannaan uutta siett varten arvoon true.

      if ( saietta_on_suoritettava  ==  true )
      {
         try
         {
            Thread.sleep( lepuutusaika_millisekunteina ) ;
            // System.out.print( " Z" ) ;  //  Rivi testausta varten
         }
         catch ( InterruptedException vangittu_poikkeus )
         {
            // System.out.print( " X" ) ;  //  Rivi testausta varten
         }
      }
   }

   public void paintComponent( Graphics graphics )
   {
      super.paintComponent( graphics ) ;

      graphics.setColor( kaytossa_oleva_vari ) ;

      graphics.fillRoundRect( madon_paikka_x, madon_paikka_y,
                              madon_pituus, madon_korkeus, 20, 20  ) ;
   }
}


class MatoFrame extends JFrame implements WindowListener
{
   static final int FRAME_WIDTH   =  620 ;
   static final int FRAME_HEIGHT  =  480 ;

   MatoPanel  paneeli_madolle ;

   public MatoFrame()
   {
      setTitle( "MatoPanelApplication.java" ) ;
      setSize( FRAME_WIDTH, FRAME_HEIGHT ) ;

      paneeli_madolle = new MatoPanel( FRAME_WIDTH, FRAME_HEIGHT ) ;

      Container content_pane = getContentPane() ;
      content_pane.add( paneeli_madolle ) ;

      addWindowListener( this ) ;
   }

   public void windowClosing( WindowEvent event )
   {
      paneeli_madolle.lopeta_saie() ;
      setVisible( false ) ;
      System.exit( 0 ) ;
   }

   public void windowActivated( WindowEvent event )
   {
   }

   public void windowDeactivated( WindowEvent event )
   {
   }


   public void windowClosed( WindowEvent event )
   {
      paneeli_madolle.lopeta_saie() ;
   }

   public void windowDeiconified( WindowEvent event )
   {
      paneeli_madolle.kaynnista_saie() ;
   }

   public void windowIconified( WindowEvent event )
   {
      paneeli_madolle.lopeta_saie() ;
   }

   public void windowOpened( WindowEvent event )
   {
      paneeli_madolle.kaynnista_saie() ;
   }

}


public class MatoPanelApplication
{
   public static void main( String[] not_in_use )
   {
      MatoFrame mato_frame = new MatoFrame() ;

      mato_frame.setVisible( true ) ;
   }
}









